package org.greenstone.android.tipple.base;

import java.util.List;
import java.util.HashMap;
//import java.util.ArrayList;

public class TipLocation 
{
	
	// Text and/or Audio associated with (Latitude,Longitude) location with radius
	
	private double latitude_;
	private double longitude_;
	
	private double radiusInKM_;
	//private double avgRadLatLong_;
	
	private String title_;
	private String text_;
	private String tts_text_;
	
	
	private String audioFilename_;
	private List<String> audioPaths_;
	
	protected String id_;
	
	public TipLocation(HashMap<String,String> hashmap)
	{
		latitude_  = Double.parseDouble(hashmap.get("latitude"));
		longitude_ = Double.parseDouble(hashmap.get("longitude"));
		radiusInKM_ = Double.parseDouble(hashmap.get("radius"));
		
		title_ = hashmap.get("title");
		text_  = hashmap.get("text");
		tts_text_ = (hashmap.containsKey("tts")) ? hashmap.get("tts") : null;
		
		audioFilename_ = hashmap.get("audio");
		
		// Consolidate whitespace
		title_ = title_.replaceAll("^\\s+", "");
		title_ = title_.replaceAll("\\s+$", "");
		title_ = title_.replaceAll("\\s+", " ");

		if (text_ != null) {
			text_ = text_.replaceAll("^\\s+", "");
			text_ = text_.replaceAll("\\s+$", "");
			text_ = text_.replaceAll("\\s+", " ");
		}
		
		id_ = title_.replaceAll("/\\s+/", "-");
	}
	
	
	public double getLatitude() 
	{
		return latitude_;
	}
	
	public double getLongitude() 
	{
		return longitude_;
	}
	
	public double getRadiusKM() 
	{
		return radiusInKM_;
	}

	public String getText() 
	{
		return text_;
	}
	
	public String getTTSText()
	{
		return (tts_text_ != null) ? tts_text_ : text_;
	}
	public String getTitle() 
	{
		return title_;
	}
	
	public String getID()
	{
		return id_;
	}
	
	public List<String> getAudio() 
	{
		return audioPaths_;
	}
	
	public String getAudioFilename()
	{
		return audioFilename_;
	}
	
}
