package org.greenstone.android.tipple.base;

import java.util.HashMap;
import java.util.ArrayList;

import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

public class XMLToHashmapHandler extends DefaultHandler 
{
	String lockon_element_;
	Boolean locked_on_;
	ArrayList<HashMap<String,String>> lockon_list_; 
	
	HashMap<String,String> hashmap_;
	String active_element_;
	StringBuffer inner_text_;
	
	public XMLToHashmapHandler(String lockon_element)
	{
		// initial settings to parse a file	
		lockon_element_ = lockon_element;
		lockon_list_ = new ArrayList<HashMap<String,String>>();
		locked_on_ = false;
	}
	
	public ArrayList<HashMap<String,String>> getHashmapList() 
	{
		return lockon_list_;
	}

	@Override
	public void startElement(String uri, String localName, String qName, Attributes attributes) 
		throws SAXException 
	{
		if (localName.equalsIgnoreCase(lockon_element_)) {
			hashmap_ = new HashMap<String,String>();
			locked_on_ = true; // => covert each child element inside this to a hashmap key
		}
		else if (locked_on_) {
			active_element_ = localName.toLowerCase();
			inner_text_ = new StringBuffer();
		}
		// else ignore element as outside area of interest
	}

	@Override
	public void endElement(String uri, String localName, String qName) 
		throws SAXException 
	{
		if (localName.equalsIgnoreCase(lockon_element_)) {
			// push hashmap onto arraylist
			lockon_list_.add(hashmap_);
			hashmap_ = null;
			
			locked_on_ = false;
		}
		else if (localName.equalsIgnoreCase(active_element_))
		{
			// add 'inner_text_' into hashmap under the key 'active_element_';
			hashmap_.put(active_element_,inner_text_.toString());
			//Log.d("***", "Saving: " + active_element_+ " = " + inner_text_.toString() + "\n");
			active_element_ = null;
			inner_text_ = null;
		}
	}

	@Override
	public void characters(char[] ch, int start, int length)
		throws SAXException 
	{
		if ((locked_on_) && (active_element_ != null)) {
			String text = new String(ch,start,length);
			inner_text_.append(text);
		}
	}

}
